<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>data.html</title>
    <script src="table.js"></script>
</head>

<body>
    <input type="text" name="center" id="center">
    <button id="findCenter">조회</button>
    <select id="sidoList">
        <option disabled>선택하세요</option>
    </select>
    <div id="show"></div>

    <script>
        //indexOf() => 인덱스값 반환
        console.log("abcdef".indexOf('b'))
        console.log("abcdef".split('').indexOf('k'))

        let url =
            'https://api.odcloud.kr/api/15077586/v1/centers?page=1&perPage=284&serviceKey=JVCo2Y%2Bzi4kNbyWSK8FFcS4WRkuax1l2wdGhstQiq9hsQqNRdkx6SM1ZsgVIVil%2BEXYQmDkNPa00mW8emdkV1Q%3D%3D';

        let allData = [];
        fetch(url)
            .then(result => result.json())
            .then(data => {
                allData = data.data; //조회된 결과를 allData 저장

                //console.log(data); //page:1, perPage:284, data: [284]... => object타입 
                //table.initData = data.data; //data:[284]를 가지고옴
                // let result = table.makeTable();
                // document.body.append(result);

                //시도정보를 초기화
                initSidoList();

                //filter(function(){})=> 함수값(조건에 맞는것들)를 새로운 배열값에 담아줌 
                let fAry = data.data.filter(function (item, idx, ary) {
                    //return item.sido == '대구광역시'; //sido가 대구광역시이면(true이면) 배열에 담아줌
                    return item.id < 10;
                });

                init(fAry);
            })
            .catch(err => console.log(err));

        //버튼이벤트(찾기)
        document.getElementById('findCenter').addEventListener('click', findCenterFnc);

        //버튼이벤트핸들러
        function findCenterFnc(e) {
            console.log(e.target.nodeName); //이벤트 대상
            //이미 테이블이 있으면 삭제 => 초기화. 새로테이블형성
            document.querySelector('#show table').remove();

            let searchKey = document.querySelector('#center').value;
            if(e.target.nodeName == 'SELECT'){
                searchKey = document.querySelector('#sidoList').value;
            }
            let searchAry = allData.filter(function (item, idx, ary) {
                if(searchKey == ''){
                    return item.sido
                }
                return item.sido == searchKey
            })
            init(searchAry);
        }

        //셀렉트이벤트(옵션체인지)
        document.getElementById('sidoList').addEventListener('change', findCenterFnc);

        //시도정보를 초기화
        function initSidoList() {
            //중복된 시도정보를 filter해서 제거
            let filterSido = [];
            for (let center of allData) {
                if (filterSido.indexOf(center.sido) == -1) { //해당되는 인덱스값 없으면 (-1)
                    filterSido.push(center.sido);
                }
            }
            console.log('000', filterSido);
            for (let sido of filterSido) {
                //옵션태그 만들어서 붙임
                let opt = document.createElement('option');
                opt.innerText = sido;
                opt.value = sido;
                document.getElementById('sidoList').append(opt);

            }
        }

        //배열데이터 화면에 출력.
        function init(aryData) {

            let table = document.createElement('table');
            table.setAttribute('border', '1')
            table.append(thead());
            table.append(tbody(aryData));


            document.getElementById('show').append(table);
        }

        //thead, tbody, tr
        const showField = ['id', 'centerName', 'address', 'phoneNumber', 'sido'];

        function thead() {
            let thead = document.createElement('thead');
            let tr = document.createElement('tr');
            showField.forEach(field => {
                let th = document.createElement('th');
                th.innerText = field;
                tr.append(th);
            })
            thead.append(tr);
            return thead;
        }

        function tbody(aryData = []) { //=[]여러건 넘어오겠다는 의미
            let tbody = document.createElement('tbody');
            aryData.forEach(center => {
                tbody.append(maekTr(center));
            })
            return tbody;
        }

        function maekTr(center = {}) { //={}오브젝트타입으로 넘어옴
            let tr = document.createElement('tr');
            for (let prop of showField) {
                let td = document.createElement('td');
                if(prop == 'centerName'){
                    let ahref = document.createElement('a');
                    ahref.setAttribute('href', 'app.html?x='+center.lat+'&y='+center.lng);
                    ahref.setAttribute('target', '_blank')
                    ahref.innerText = center[prop];
                    td.append(ahref);
                }else{
                    td.innerText = center[prop];
                    //prop=>속성 (address, id, ....)
                    //center[prop] => ex) 이 객체의 address값(address: ?)
                }
                tr.append(td);
            }

            return tr

        }
    </script>
</body>

</html>